// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AFX_STDAFX_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_)
#define AFX_STDAFX_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers

#include <windows.h>

#define WHITE				RGB(255,255,255)
#define BLUE				RGB(0,0,204)

#define MAINWIDTH 625
#define MAINDEPTH 500

#define TFTP_PORT 69

// operations
#define COP_IDLE 				0
#define COP_CLIENT_UPLOAD		1
#define COP_CLIENT_DOWNLOAD		2

#define STATUS_IDLE					0
#define STATUS_OPENING_FILE			1
#define STATUS_CONNECTING			2
#define STATUS_TRANSFERRING_DATA	3
#define STATUS_COMPLETE 			4
#define STATUS_TIMEDOUT				5
#define STATUS_ABORTED				6
#define STATUS_ABORTED_FIO			7

#define FBLOCK_SZ				16384

#define LSWAP_ENDIAN(x)				( (((x) & 0xFF000000) >> 24) | \
									  (((x) & 0x00FF0000) >> 8 ) | \
									  (((x) & 0x0000FF00) << 8 ) | \
									  ( (x) << 24) )

#define MAX_EVENTS 			1000

typedef struct
{
	unsigned short tftp_port;
	DWORD		dest_ip;
} conf_t; 

/* server connection context */
typedef struct server_conn_ctx_t server_conn_ctx_t;
typedef struct server_conn_ctx_t
{
	int					is_server_session;
	int					is_send;

	HANDLE				hFile;		// file handle currently operated on
	long 				tftp_handle; // TFTP module context handle

	unsigned char		rxbuf[FBLOCK_SZ];
	int					rxbuf_ptr;
	int					rxbuf_len;

	unsigned char 		*fblock;
	int					fblock_len;
	int					fblock_ptr;

	unsigned int 		bytes_nr;
	unsigned int 		block_nr;
	int					progress;

	server_conn_ctx_t	*pNext;			// ptr to next connection context
	server_conn_ctx_t	*pPrev;			// ptr to prev connection context;
} server_conn_ctx_t;

#define TFTP_MAX_CTXS	10
typedef struct
{
	server_conn_ctx_t	*head;
	server_conn_ctx_t	*tail;
	int					count;		// number of allocated contexts
} server_conn_list_t;

#define HS_VERSION "1.3.0"

static void hs_tftp_cleanup_ctx(server_conn_ctx_t *pCtx);

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_)
